/*
 *	socksetup
 *	BSD socket 
 *
 *	Authors: SHUDOH Kazuyuki
 *	$Id$
 */
#include <stdio.h>
#include <string.h>	/* for bzero() */
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>	/* for inet_addr() */

#ifndef INADDR_NONE	/* exist on Linux, not on SunOS[45] */
# define INADDR_NONE -1
#endif

#define SUCCESS 0
#define FAILURE -1


/*
 * Desc: hostname (¦Ǥ NULL ), port  sockaddr 
 * Returns: 0 if success, -1 if fail
 */
int SetSockAddr(addrp, hname, port)
    struct sockaddr_in *addrp;	/* ꤵ */
    char *hname;	/* my hostname or dotted-decimal */
    int port;
{
    unsigned long inaddr;
    struct hostent *hp;

    bzero((char *)addrp, sizeof(struct sockaddr_in));
    addrp->sin_family = AF_INET;

    addrp->sin_port = htons((unsigned short)port);

    if (hname) {
	if ((inaddr = inet_addr(hname)) != INADDR_NONE) { /* dotted-decimal */
	    memcpy((char *)&addrp->sin_addr, (char *)&inaddr, sizeof(inaddr));
	    /* unsigned long -> in_addr */
	}
	else {
	    if (!(hp = gethostbyname(hname))) {
		perror("SetSockAddr");
		return FAILURE;
	    }
#if 0
	    addrp->sin_family = hp->h_addrtype;	/* AF_INET */
#else
	    addrp->sin_family = AF_INET;
#endif
	    memcpy((char *)&addrp->sin_addr,(char *)hp->h_addr, hp->h_length);
	}
    }
#if 0	/* not needed */
    else {
	addrp->sin_addr.s_addr = htonl(INADDR_ANY);
    }
#endif

    return SUCCESS;
}
