/*
 *	tcpconnect.c
 *	TCP ³
 *
 *	Authors: SHUDOH Kazuyuki
 *	$Id$
 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define FAILURE	-1

#define REUSE_SOCKADDR

/*
 * Desc:    TCP ³¦ setup (connect() ޤǹԤʤ)
 * Returns: fd if success, -1 if fail
 */
int TcpConnect(addrp)
    struct sockaddr_in *addrp;	/* ³ sockaddr */
{
    int sock;
    int flag = 1;	/* for setsockopt() */

    if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	perror("TcpConnect: socket");
	return FAILURE;
    }
#if 0
#ifdef REUSE_SOCKADDR
    if (setsockopt(sock,SOL_SOCKET,SO_REUSEADDR,(char *)&flag,sizeof(flag))<0) {
	perror("TcpSetup: setsockopt");
	return FAILURE;
    }
#endif
#endif

    if (connect(sock, (struct sockaddr *)addrp, sizeof(struct sockaddr)) < 0) {
	perror("TcpConnect: connect");
	return FAILURE;
    }

    return sock;
}
