/*
 *	tcpsetup.c
 *	TCP 
 *
 *	Authors: SHUDOH Kazuyuki
 *	$Id$
 */
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define FAILURE	-1

#define REUSE_SOCKADDR

/*
 * Desc:    TCP μ¦ setup (listen() ޤǹԤʤ)
 * Returns: fd if success, -1 if fail
 */
int TcpSetup(addrp, backlog)
    struct sockaddr_in *addrp;	/* ʬ sockaddr */
    int backlog;
{
    static char funcname[] = "TcpSetup";

    int lsock;
    int flag = 1;	/* for setsockopt() */

    if ((lsock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	perror("TcpSetup: socket");
	return FAILURE;
    }
#ifdef REUSE_SOCKADDR
    if (setsockopt(lsock,SOL_SOCKET,SO_REUSEADDR,(char *)&flag,sizeof(flag))<0){
	perror("TcpSetup: setsockopt");
	return FAILURE;
    }
#endif

    if (bind(lsock, (struct sockaddr *)addrp, sizeof(struct sockaddr)) < 0) {
	perror("TcpSetup: bind");
	return FAILURE;
    }

    if (listen(lsock, backlog) < 0) {
	perror("TcpSetup: listen");
	return FAILURE;
    }

    return lsock;
}
