#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include "commudp.h"

#define PORT_SERV 10005
#define BUF_LEN 32000
/*
  on SunOS 5.4
  65508: OK
  65509: NG

  on Linux 1.2.8
  32614:       OK.
  32615-32630: 뤬ʤ
  32640:       

  cf:
  32K is 32768
  64K is 65536
 */

#define MESG "hello, I'm server."

int main(argc, argv)
     int argc;
     char **argv;
{
    int sock, n;
    char mesg_send[BUF_LEN], mesg_recv[BUF_LEN];
    char hname[MAXHOSTNAMELEN];	/* my name (server only) */
    struct sockaddr_in sin, from;  int acptlen, fromlen;


    if (argc < 2) {	/* I'm server */
	strncpy(mesg_send, MESG, BUF_LEN);	/* åν */

	/* ѥåȤκ */
	if (SetSockAddr(&sin, NULL, PORT_SERV) < 0)  exit(1);
	if ((sock = UdpSetup(&sin)) < 0)  exit(1);

	while (1) {
	    /*  */
	    fromlen = sizeof(from);	/* ɬ */
	    acptlen = recvfrom(sock, mesg_recv, BUF_LEN,
			       0, (struct sockaddr *)&from, &fromlen);
	    if (acptlen < 0)
		fprintf(stderr, "recvfrom error\n");

	    /*  */
	    if (sendto(sock, mesg_send, BUF_LEN,
		       0, (struct sockaddr *)&from, fromlen) != BUF_LEN)
		fprintf(stderr, "send error\n");

	    strncpy(mesg_send, mesg_recv, BUF_LEN);
	}
    }
    if (argc < 3) {
	fprintf(stderr, "too few arguments.\n");
	exit(1);
    }
    else {		/* I'm client */
	/* ѥåȤκ */
	if (SetSockAddr(&sin, NULL, 0) < 0)  exit(1);
	if ((sock = UdpSetup(&sin)) < 0)  exit(1);

	if (SetSockAddr(&from, argv[1], PORT_SERV) < 0)  exit(1);
		/*  sockaddr κ */

	strcpy(mesg_send, argv[2]);

	fromlen = sizeof(from);		/* ɬ */

fprintf(stderr, "tend to send....\n");
	/*  */
	if ((n = sendto(sock, mesg_send, BUF_LEN,
		   0, (struct sockaddr *)&from, fromlen)) != BUF_LEN) {
	    fprintf(stderr, "send error: %d\n", n);
	    exit(1);
	}
fprintf(stderr, "sent.\n");

	/*  */
	acptlen = recvfrom(sock, mesg_recv, BUF_LEN,
			   0, (struct sockaddr *)&from, &fromlen);

	printf("mesg: %s\n", mesg_recv);

	exit(0);
    }
}
