/*
 * test code for udpcomm.c
 *	Authors: SHUDOH Kazuyuki
 */

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <fcntl.h>	/* for open() */
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include "commudp.h"

#define PORT_SERV 10005
#define PKT_SIZE 256

#if 0
#define BUF_LEN BUFSIZ	/* 1024 on Linux */
#else
#define BUF_LEN 4096
#endif


int main(argc, argv)
     int argc;
     char **argv;
{
    int fd;
    char msg[BUF_LEN];
    int nbyte;
    struct sockaddr_in sin, from;


    if (argc == 1) {	/* I'm server */
	UdpInit(PORT_SERV);	/* ɬפʽ */

	while(1) {
	    if ((nbyte = UdpRecv(&from, msg, PKT_SIZE)) < 0) {
		perror("UdpRecv");
		exit(1);
	    }
/* fprintf(stderr, "received: %d bytes\n", nbyte); */

	    if (write(1, msg, nbyte) != nbyte)  perror("write");
	}
    }


    if (argc == 3) {	/* I'm client */
	/* argv[1]: host, argv[2]: file */

	if (SetSockAddr(&sin, argv[1], PORT_SERV) < 0)  exit(1);
		/*  sockaddr κ */


	if ((fd = open(argv[2], O_RDONLY, 0)) < 0) {
	    perror("open");
	    exit(1);
	}

	do {
	    if ((nbyte = read(fd, msg, BUF_LEN)) < 0) {
		perror("read");
		exit(1);
	    }
	    if (nbyte == 0)  break;
fprintf(stderr, "read: %d bytes\n", nbyte);

	    if (UdpSend(&sin, msg, nbyte, PKT_SIZE) != nbyte) {
		perror("UdpSend");
		exit(1);
	    }
	} while (nbyte == BUF_LEN);

	exit(0);
    }
    else {
	printf("Usage: %s (server)\n"
	       "    or %s <hostname> <filename> (client)\n",
	       argv[0], argv[0]);
	exit(1);
    }
}
