/*
 *	udpcomm.c
 *	UDP ̿
 *
 *	Authors: SHUDOH Kazuyuki
 *	$Id$
 */
#include <stdio.h>
#include <unistd.h>	/* for close() */
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include "commudp.h"

#define MIN(a,b) ((a)<(b)?(a):(b))	/* for UdpSend() */

#define FAILURE -1

static int sock = -1;	/* for receive */


/*
 * Desc: *addrp  msg (msglen Х)  MTU ХȤʬ䤷
 *       ʤ
 * Returns: the number of bytes received if success, -1 if fail
 */
int UdpSend(addrp, msg, msglen, mtu)
    struct sockaddr_in *addrp;
    char *msg;
    int msglen;
    int mtu;		/* Maximum Transmit Unit */
{
    static int sd = -1;
    struct sockaddr_in sin;
    int addrlen;
    int pktlen, nbyte;
    char *msgsend, *msglast;

    msglast = msg + msglen;
    msgsend = msg;		/* point to message to be sent */

    /* ѥåȤκ */
    if (SetSockAddr(&sin, NULL, 0) < 0)  return FAILURE;
    if (sd >= 0)  close(sd);
    if ((sd = UdpSetup(&sin)) < 0)  return FAILURE;

    while (msgsend < msglast) {
	pktlen = MIN(mtu, (int)(msglast - msgsend));

	addrlen = sizeof(struct sockaddr);
	nbyte = sendto(sd, msgsend, pktlen,
		       0, (struct sockaddr *)addrp, addrlen);
	if (nbyte != pktlen)  return FAILURE;

	msgsend += nbyte;
    }

    close(sd);

    return msglen;
}


/*
 * Desc: ɬפʽԤ
 * Returns: socket if success, -1 if fail
 */
int UdpInit(port)
    int port;
{
    struct sockaddr_in sin;

    /* ѥåȤκ (1٤) */
    if (sock < 0) {	/* sock is global var. */
	if (SetSockAddr(&sin, NULL, port) < 0)  return FAILURE;
	if ((sock = UdpSetup(&sin)) < 0)  return FAILURE;
    }

    return sock;
}


/*
 * Desc: msg (MRU Х) 
 *       *fromp Υåȥɥ쥹֤
 *       ʤ
 * Returns: the number of bytes received if success, -1 if fail
 */
int UdpRecv(fromp, msg, mru)
    struct sockaddr_in *fromp;
    char *msg;
    int mru;		/* Maximum Receive Unit */
{
    int fromlen;
    int nbyte;

    fromlen = sizeof(struct sockaddr);
    nbyte = recvfrom(sock, msg, mru,
		     0, (struct sockaddr *)fromp, &fromlen);

    if (nbyte < 0)  return FAILURE;
    return nbyte;
}
