/*
 *	udpsetup.c
 *	UDP ط
 *
 *	Authors: SHUDOH Kazuyuki
 *	$Id$
 */
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define FAILURE	-1

#define REUSE_SOCKADDR

/*
 * Desc: sockaddr  bind  UDP socket ֤
 * Returns: fd if success, -1 if fail
 */
int UdpSetup(addrp)
    struct sockaddr_in *addrp;
{
    int sock;
    int flag = 1;	/* for setsockopt() */

    if ((sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
	perror("UdpSetup: socket");
	return FAILURE;
    }
#ifdef REUSE_SOCKADDR
    if (setsockopt(sock,SOL_SOCKET,SO_REUSEADDR,(char *)&flag,sizeof(flag)) < 0) {
	perror("UdpSetup: setsockopt");
	return FAILURE;
    }
#endif

    if (bind(sock, (struct sockaddr *)addrp, sizeof(struct sockaddr)) < 0) {
	perror("UdpSetup: bind");
	return FAILURE;
    }

    return sock;
}
